open Printf;;

close_graph ();;
open_graph " 1000x300-0-64";;  


#use "cella2.ml";;

let create_cn n =
  {tab = Array.init n (fun i -> [|if i <= 0 then -1 else i - 1;
				  if i >= n - 1 then -1 else i + 1|]);
   pos = Array.init n (fun i -> (988 - 30 * (i mod 33), 285 - 30 * (i / 33)))
  };;

let bit x n =
  if x = sharp then false
  else ((x lsr n) land 1) == 1;;

let c : colfun =
  fun s ->
    if (bit s 0) then
      if (bit s 1) then green
      else red
    else white
;;

(*
  vert = nb de noeuds premier
  rouge = nb de noeuds compos
*)

let f : tfun =
  fun s n ->
    let x = ref s
    in let set n b =
	x := (if b 
	      then !x lor (1 lsl n)
	      else !x land (lnot (1 lsl n)))
    in (match n with
	    [|-1;-1|] -> ()
	  | [|-1;d|] -> 
	      set 2 (bit d 9);
	      set 6 (bit s 7);
	      set 7 (bit d 7);
	      set 10 (bit d 10);
	      if (bit d 10) then set 1 (bit d 1)
	  | [|g;-1|] ->
	      set 9 false;
	      set 3 (bit g 5);
	      set 4 (bit s 3);
	      set 5 (bit s 4);
	      set 2 (bit g 2);
	      if (bit g 2) && (not (bit g 0)) then set 3 true;
	      if (bit s 2) then
		(if not (bit s 0) then
		   begin
		     set 0 true;
		     set 1 true;
		     set 9 true;
		   end
		 else set 10 true);
	      if (bit s 4) then
		(set 9 true;
		 if (bit g 6) then 
		   (set 0 true;
		    set 1 false))
	  | [|g;d|] ->
	      if (bit d 10) then
		begin
		  set 10 true;
		  set 0 true;
		  set 1 (bit d 1);
		  set 8 false;
		end
	      else
		begin
		  set 9 (bit d 9);
		  set 2 (bit g 2);
		  set 8 (bit s 8);
		  if (bit s 9) then set 8 false;

		  set 3 (bit g 5);
		  set 4 (bit s 3);
		  set 5 (bit s 4);

		  set 6 (bit g 6);
		  set 7 (bit d 7);
		  if (bit s 2) then
		    (set 2 false;
		     if not (bit s 0) then
		       (set 0 true;
			set 1 true;
			set 8 true;
			set 7 true));
		  if (bit g 2) && (not (bit g 0)) then
		    (set 3 true;
		     set 2 false);

		  if (bit s 8) && (bit d 7) then
		    (set 7 false;
		     set 6 true;
		     set 8 false);
		  if (bit s 4) && (bit g 6) then
		    (set 6 false;
		     set 7 true;
		     set 8 true;
		     set 0 true;
		     set 1 false)
		end
	  | _ -> failwith "ah!");
      !x  
;;


let descr =
  [|"known ";
    "prime ";
    "start ";
    "rack0 ";
    "rack1 ";
    "rack2 ";
    "ball_a";
    "ball_r";
    "table ";
    "done  ";
    "finish"|]
;;

let print_status status =
  for i = 0 to 10 do
    begin
      printf "%s " descr.(i);
      for j = (Array.length status) - 1 downto 0 do 
	printf " %d" (if (bit status.(j) i) then 1 else 0)
      done;
      printf "\n"
    end
  done;;

let init_status n = 
  let tab = Array.make n 0
  in tab.(0) <- 5; tab;;

let speed = ref (0.0);;

let run n = 
  let g = (create_cn n) 
  and s = (init_status n)
  in let (step, stop) = stepper g f s
  and cpt = ref (-1)
  in 
    begin
      if !speed == 0.0 then print_status s
      else draw_first g c s;
      while not !stop do
	let s = step ()
	in
	  begin
	    if (!speed = 0.0) then 
	      begin
		read_line ();
		print_status s
	      end
	    else
	      begin
		mysleep !speed;
		draw_nodes g (Array.map c s)
	      end;
	      cpt := !cpt + 1
	  end
      done;
      printf "<%d> transitions.\n" !cpt
    end;;
    
